#include <stdio.h>
#include <stdlib.h>
#include "../include/AbcCWindow.h"
//#include "../include/xinput.h"

//*******************************************************************
// Abstract Class CWindow for input grabber window
// Constructor for CWindow Class
//*******************************************************************
 CWindow::CWindow()
 {
   //strcpy(argv[0],"xinput");
   //strcpy(progname,"xinput");
  // int argc=1;
   border_width = 0;
  
 }
//*******************************************************************
// Initialises and Displays Input Grabber Window (Simple Window)
//*******************************************************************
 void CWindow::CWindowInit()
{
   char *str[1]={"WM_DELETE_WINDOW"};
   char *window_name = "Input Grabber Window";
   char *icon_name = "Input Grabber";
   char *argv[]={"xinput"};
   char *display_name = NULL;
   progname = argv[0];
   
   if (!(size_hints = XAllocSizeHints())) 
   {
        fprintf(stderr, "%s: failure allocating memory", progname);
        exit(0);
   }
   
   if (!(wm_hints = XAllocWMHints())) 
   {
        fprintf(stderr, "%s: failure allocating memory", progname);
        exit(0);
   }
   
   if (!(class_hints = XAllocClassHint())) 
   {
        fprintf(stderr, "%s: failure allocating memory", progname);
        exit(0);
   }
   
   if ( (display=XOpenDisplay(display_name)) == NULL )
   {
           fprintf( stderr, "%s: cannot connect to X server %s\n", progname, XDisplayName(display_name));
           exit(0);
   }
   screen_num 	  = DefaultScreen(display);
   display_width  = DisplayWidth(display, screen_num);
   display_height = DisplayHeight(display, screen_num);
   width          = display_width/50,height = display_height/50;
   win            = XCreateSimpleWindow(display, RootWindow(display,screen_num),x, y, width, height, border_width,WhitePixel(display,screen_num), BlackPixel(display,screen_num));

 //  int revert_to;
  // XGetInputFocus(display,&win,&revert_to);//Extra Added
   XInternAtoms(display,str,1,True,Protocol);
   XSetWMProtocols(display,win,Protocol,1);
  
   if (XGetIconSizes(display, RootWindow(display,screen_num),&size_list, &count) == 0)
          fprintf( stderr, "%s: Window manager didn't set icon sizes - using default.\n", progname);

   size_hints->flags 	  = PPosition | PSize | PMinSize;
   size_hints->min_width  = 200;
   size_hints->min_height = 1;
   
   if (XStringListToTextProperty(&window_name, 1, &windowName) == 0) 
   {
      fprintf( stderr, "%s: structure allocation for windowName failed.\n", progname);
      exit(0);
   }

   if (XStringListToTextProperty(&icon_name, 1, &iconName) == 0) 
   {
      fprintf( stderr, "%s: structure allocation for iconName failed.\n", progname);
      exit(0);
   }
  
   wm_hints->initial_state = NormalState;
   wm_hints->input         = True;
   wm_hints->icon_pixmap   = icon_pixmap;
   wm_hints->flags         = StateHint | IconPixmapHint | InputHint;
   class_hints->res_name   = progname;
   class_hints->res_class  = "Basicwin";
   
   XSetWMProperties(display, win, &windowName, &iconName, argv, argc, size_hints, wm_hints, class_hints);
  
   
   XSelectInput(display, win, ExposureMask | KeyPressMask | ButtonPressMask | StructureNotifyMask);
   
   CWindowLoadFont(&font_info);
   
   CWindowGetGC(win, &gc, font_info);
   
   XMapWindow(display, win);
   XFlush(display);
      
       for(;;) {
               XEvent e;

                XNextEvent(display, &e);
                     if (e.type == MapNotify)
                              break;
              }


 }
//*******************************************************************
// Class CWindow Get Graphics Context
//*******************************************************************
void CWindow::CWindowGetGC(Window win,GC *gc,XFontStruct *font_info)
{
   unsigned long valuemask = 0;

   XGCValues values;
   unsigned int line_width = 6;
   int line_style = LineOnOffDash;
   int cap_style = CapRound;
   int join_style = JoinRound;
   int dash_offset = 0;
   static char dash_list[] = {12, 24};
   int list_length = 2;
   
   *gc = XCreateGC(display, win, valuemask, &values);
   
   XSetFont(display, *gc, font_info->fid);
   
   
   XSetForeground(display, *gc, BlackPixel(display,screen_num));
   XSetLineAttributes(display, *gc, line_width, line_style, cap_style, join_style);
   XSetDashes(display, *gc, dash_offset, dash_list, list_length);


}
//*******************************************************************
// Class CWindow Load Font
//*******************************************************************
void CWindow::CWindowLoadFont(XFontStruct **font_info)
{
   char *fontname = "9x15";

   if ((*font_info = XLoadQueryFont(display,fontname)) == NULL)
   {
      fprintf( stderr, "%s: Cannot open 9x15 font\n",  progname);
      exit( -1 );
   }
}
//*******************************************************************
// Class CWindow Place Text On Window
//*******************************************************************
void CWindow::CWindowPlaceText(Window win,GC gc, XFontStruct *font_info, unsigned int win_width, unsigned int win_height)
{
   char *string1 = "Developed By : Sachin Chavan";
   char *string2 = "E-mail : sachin.a.chavan@gmail.com";
   char *string3 = "Copyright (c) 2005";
   char *string4 = "Released Under GPL Licence";
   int len1, len2, len3, len4;
   int width1, width2, width3;
   char cd_height[50], cd_width[50], cd_depth[50];
   int font_height;
   int initial_y_offset, x_offset;
     
   len1 = strlen(string1);
   len2 = strlen(string2);
   len3 = strlen(string3);
   
   width1 = XTextWidth(font_info, string1, len1);
   width2 = XTextWidth(font_info, string2, len2);
   width3 = XTextWidth(font_info, string3, len3);
   font_height = font_info->ascent + font_info->descent;
      
   XDrawString(display, win, gc, (win_width - width1)/2,font_height,string1, len1);
   XDrawString(display, win, gc, (win_width - width2)/2,(int)(win_height - (2 * font_height)),string2, len2);
   XDrawString(display, win, gc, (win_width - width3)/2, (int)(win_height - font_height), string3, len3);
   
   sprintf(cd_height, " Height - %d pixels", DisplayHeight(display,screen_num));
   sprintf(cd_width,  " Width  - %d pixels",  DisplayWidth(display,screen_num));
   sprintf(cd_depth,  " Depth  - %d plane(s)",DefaultDepth(display, screen_num));
   
   len4 = strlen(string4);
   len1 = strlen(cd_height);
   len2 = strlen(cd_width);
   len3 = strlen(cd_depth);
   initial_y_offset = win_height/2 - font_height - font_info->descent;
   x_offset = (int) win_width/4;
   XDrawString(display, win, gc, x_offset, (int) initial_y_offset,string4,len4);
   XDrawString(display, win, gc, x_offset, (int) initial_y_offset +font_height,cd_height,len1);
   XDrawString(display, win, gc, x_offset, (int) initial_y_offset + 2 * font_height,cd_width,len2);
   XDrawString(display, win, gc, x_offset, (int) initial_y_offset +3 * font_height,cd_depth,len3);
}
//*******************************************************************
// Class CWindow Place Some Graphics on Window
//*******************************************************************
void CWindow::CWindowPlaceGraphics(Window win, GC gc, unsigned int window_width, unsigned int window_height)
{
   int x, y;
   int width, height;
   height = window_height/2;
   width = 3 * window_width/4;
   x = window_width/2 - width/2;
   y = window_height/2 - height/2;
   XDrawRectangle(display, win, gc, x, y, width, height);

}
//*******************************************************************
// Class CWindow Place ToSmall Validation
//*******************************************************************
void CWindow::TooSmall(Window win, GC gc,XFontStruct *font_info)
{
   char *string1 = "Too Small";
   int y_offset, x_offset;
   y_offset = font_info->ascent + 2;
   x_offset = 2;
   
   XDrawString(display, win, gc, x_offset, y_offset, string1,strlen(string1));

}
CWindow::~CWindow()
{ 

}
//*******************************************************************
// Class CWindow Ends Here
//*******************************************************************
