#include <stdio.h>

#include "../include/CStack.h"

//***************************************************************************
// CStack Constructor
//***************************************************************************
CStack:: CStack()
{
  top=NULL;
  no_of_elements=0;

}
//***************************************************************************
// CStack Destructor
//***************************************************************************
CStack::~CStack()
{


}
//***************************************************************************
// Pushes one element on stack
//***************************************************************************
void CStack::Push(char data)
{
  node *temp;
  temp=new node;
  temp->data=data;
  temp->link=top;
  top=temp;
  no_of_elements++;
}
//***************************************************************************
// Pop one element from stack
//***************************************************************************
char CStack::Pop()
{
 char ch=0;
 node *temp;
 if(top!=NULL)
 {
    temp=top;
    ch=temp->data;
    top=top->link;
    delete temp;
    no_of_elements--;
 }
 return ch;
}
//***************************************************************************
// Characters present on the stack converted to String
//***************************************************************************
void CStack::ToString(char *str)
{
 node *temp;
 temp=top;
 if(no_of_elements)
 {
 	int i=0;
 	while(temp->link!=NULL)
 	{
 	  str[i]=temp->data;
 	  temp=temp->link;
 	  i++;
 	}
 	 str[i++]=temp->data;
   
 	 str[i]=0;
 }
 else 
   str[0]=0;
 
}
//***************************************************************************
// Makes stack empty
//***************************************************************************
void CStack::PopAll()
{
 node *temp;
 while(top!=NULL)
 {
  temp=top;
  top=top->link;
  delete temp;
 }
  no_of_elements=0;
}
//***************************************************************************
// Returns No of nodes present on stack
//***************************************************************************
unsigned int CStack::NumberOfNodes()
{
 return(no_of_elements);
}
//***************************************************************************
// End Of CStack Class
//***************************************************************************
