#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <stdio.h>
#include <fstream>
#include <iomanip>
#include "../include/GrabKeyboard.h"
#include "../include/CStack.h"

using namespace std;

GrabKeyboard::GrabKeyboard()
{

}
//*****************************************************************************
// CWindow Event Loop
//*****************************************************************************
void GrabKeyboard:: CEventLoop(unsigned int Selected)
{
   int error,revert_to;
   char KeySymString[20];
   char Buffer[20];
   KeySym keysym;
   CStack Stack;
   XMapRaised(display,win);
 
   
   error = XGrabKeyboard(display, win, True, GrabModeAsync, GrabModeAsync, CurrentTime);
   
  if (error==AlreadyGrabbed) 
  {
     printf("Some other app has grabbed the keyboard.\n");
     XFreeGC(display, gc);
     XCloseDisplay(display);
     return;
  }
  
  if (error==GrabNotViewable) 
  {
   printf("Please Maximize the input grabber Window.\n");
   XFreeGC(display, gc);
   XCloseDisplay(display);
   return;
  }
  
  if (error==GrabFrozen) 
  {
   printf("Some monster app has frozen the keyboard.\n");
   XFreeGC(display, gc);
   XCloseDisplay(display);
   return;
  }
 
   KeySym KeyMap[120];
   for(int i=0;i<120;i++)
   {
    KeyMap[i]=Selected;
    Selected++;
   }
   error=XChangeKeyboardMapping(display,120,1,KeyMap,120);
   
   if(error==BadAlloc)
   {
    printf("BadAlloc\n");
    return;
   }
  
   if(error==BadValue)
   {
    printf("BadValue\n");
    return;
   }
    
  int keycode;
  
   while (1)  {
      XNextEvent(display, &report);
    
      switch  (report.type) 
      {
       
       case MappingNotify	:    XRefreshKeyboardMapping(&report.xmapping);
        			     break;
       case  MapNotify          :  
       				    break;
       case Expose              :    
       				    break;
      
      case ConfigureNotify      :     //width = report.xconfigure.width;
         			     // height = report.xconfigure.height;
                                     // if ((width < size_hints->min_width) || (height < size_hints->min_height))
                                     // window_size = TOO_SMALL;
                                     // else
                                     // window_size = BIG_ENOUGH;
                                      break;
      
      case ButtonPress          :     printf("Button Press\n");
	  			      break;
      
      case FocusIn              :     XGetInputFocus(display,&FocusWindow,&revert_to);
  				      if(Stack.NumberOfNodes())
				      Stack.PopAll();
	                              break; 
				       
      case KeyPress             :      XGetInputFocus(display,&FocusWindow,&revert_to);
      				       XLookupString(&report.xkey,KeySymString,20,&keysym,0);
				       //SendKey(report.xkey.state,keysym);
				       
				       
				       keycode=report.xkey.keycode;
				       
				       switch(keycode)
				       {
				        case 65   :     if(Stack.NumberOfNodes())
							{
					  		    
							    Stack.ToString(Buffer);
							    CStrRev(Buffer);
							    unsigned int back;
							    for(back=0;back<Stack.NumberOfNodes();back++)
					 		    SendKey(0,"BackSpace");
							    CMap CTmp;
							    InitCMap(&CTmp);
					 
					 		    if(TransMapping[(int)*Buffer].SetCurrPos(Buffer))
							    {
					  		      CTmp=TransMapping[(int)*Buffer].CurrPosAsciiField();
					  		      int index=0;
					  		      while(!CheckBlankString(CTmp.Unicode[index]))
					  		      {
					     			SendKey(report.xkey.state,CTmp.Unicode[index]);
					     			index++;
					  		      }	
					 		    }
						 	    Stack.PopAll();
							}
							SendKey(report.xkey.state,keysym);
							
							break;
					case 22 : if(Stack.NumberOfNodes())
					           Stack.Pop();
						   SendKey(report.xkey.state,keysym);
						   break;
				        case 107 :
					case 36  : if(Stack.NumberOfNodes())
					            Stack.PopAll();
						   SendKey(report.xkey.state,keysym);
						   break;
						     		   
					case  100 :
					case  102 :
					case  103 :
					case  104 :
					case  105 :
					case  106 :      
					case  117 :     
					case  97  :
					case  98  :
					case  50  :
					case  64  :
					case   9  :
					case 114  :
					case  62  : SendKey(report.xkey.state,keysym);
					            break; 
					
							
				       
				         default     :  //printf("In default %s\n",KeySymString);
					 		SendKey(report.xkey.state,keysym);
					 		if((strlen(KeySymString)==1)&&(!CheckBlankString(KeySymString)))
				       			{ 
								Stack.Push(KeySymString[0]);
								Stack.ToString(Buffer);
								CStrRev(Buffer);
								int SetPos=TransMapping[(int)*Buffer].SetCurrPos(Buffer);
								if((Stack.NumberOfNodes()==1)&&(!SetPos))
								{
   								    Stack.PopAll();
															
								}
								else
								if(!SetPos)
								{
									CStack TStack,MStack;
									CMap CAs;
									
									InitCMap(&CAs);
									unsigned int back;
									
									for(back=0;back<Stack.NumberOfNodes();back++)
									SendKey(0,"BackSpace");
									
									do
									{
										 TStack.Push(Stack.Pop());
							 		 	 Stack.ToString(Buffer);
							 		 	 CStrRev(Buffer);
										 
                                                         			 if(TransMapping[(int)*Buffer].SetCurrPos(Buffer))
							 			 {
							  			  CAs=TransMapping[(int)*Buffer].CurrPosAsciiField();
										  
							  			  if(!strcmp(Buffer,CAs.Ascii))
										  {
										   int index=0;
									            while(!CheckBlankString(CAs.Unicode[index]))
									            {
							 			      SendKey(report.xkey.state,CAs.Unicode[index]);
							 			      index++;
									             }	
										    Stack.PopAll();		   
										    break;
										   }
										   
						  	 			 }
										
									}
									while(Stack.NumberOfNodes());//TransMapping[(int)*Buffer].SetCurrPos(Buffer));
									
									
								        
									
									while(TStack.NumberOfNodes())
							 		Stack.Push(TStack.Pop());

									Stack.ToString(Buffer);
									CStrRev(Buffer);
								        for(back=0;back<Stack.NumberOfNodes();back++)
									{
							 		    char xstr[21];

									    if(Char2XString(Buffer[back],xstr))
									    {
									       SendKey(report.xkey.state,xstr);
									    }
									    else
									    {
							 		      xstr[0]=Buffer[back];
							 		      xstr[1]=0;
									      SendKey(report.xkey.state,xstr);
									    }
							 			
									 }
									 
									 if(TransMapping[(int)*Buffer].SetCurrPos(Buffer))
									 {	
									 	InitCMap(&CAs);
									 	int i=0;
									 	do
									 	{
									 	 InitCMap(&CAs);
									 	 CAs=TransMapping[(int)*Buffer].CurrPosAsciiField();
									 	 i++;
									 	}
									 	while(TransMapping[(int)*Buffer].SetNext());
									 	if((i==1)&&(!strcmp(CAs.Ascii,Buffer)))
									 	{
									   	unsigned int back;
									   	for(back=0;back<Stack.NumberOfNodes();back++)
									  	  SendKey(0,"BackSpace");
									  
									 	 int index=0;
									  
									  	  while(!CheckBlankString(CAs.Unicode[index]))
									  	  {
							 				SendKey(report.xkey.state,CAs.Unicode[index]);
							 				index++;
									    	  } 		
									    	TransMapping[(int)*Buffer].ResetCurrPos();
									    	Stack.PopAll();
									 	}
									}


								}
								else
								{
									CMap CAs;
									int i=0;
									do
									{
									 InitCMap(&CAs);
									 CAs=TransMapping[(int)*Buffer].CurrPosAsciiField();
									 i++;
									}
									while(TransMapping[(int)*Buffer].SetNext());
									if((i==1)&&(!strcmp(CAs.Ascii,Buffer)))
									{
									  							  
									  unsigned int back;
									  for(back=0;back<Stack.NumberOfNodes();back++)
									  SendKey(0,"BackSpace");
									  
									  int index=0;
									  
									  while(!CheckBlankString(CAs.Unicode[index]))
									  {
							 			SendKey(report.xkey.state,CAs.Unicode[index]);
							 			index++;
									  }	
									  TransMapping[(int)*Buffer].ResetCurrPos();
									  Stack.PopAll();
									  
									}
									
									
								}
								
							}	
					}  
				       

 	  
	                               break;
      case ClientMessage        :
				       XCloseDisplay(display);
        			       return;
	    				
      }
   }
}
void GrabKeyboard::SendKey(unsigned int state, KeySym keysym)
{

  XKeyEvent key_event;
 

  key_event.display 	= display;
  key_event.window 	= FocusWindow;
  key_event.root 	= RootWindow(display, DefaultScreen(display));
  key_event.subwindow 	= None;
  //key_event.time 	= CurrentTime;
  key_event.x 		= 1;
  key_event.y 		= 1;
  key_event.x_root 	= 1;
  key_event.y_root	= 1;
  key_event.same_screen = true;
  key_event.state 	= state;
  
  key_event.keycode 	= XKeysymToKeycode(display, keysym);
  

  key_event.type = KeyPress;
  int error = XSendEvent(display, FocusWindow, True, KeyPressMask|KeyReleaseMask, (XEvent *)&key_event);
  //assert(error);
  if (error==BadValue) 
   printf("Bad Value.\n");
   
  if (error==BadWindow) 
   printf("Bad Window.\n");
}

void GrabKeyboard::SendKey(unsigned int state, char *keysymstring)
{

  XKeyEvent key_event;
 

  key_event.display 	= display;
  key_event.window 	= FocusWindow;
  key_event.root 	= RootWindow(display, DefaultScreen(display));
  key_event.subwindow 	= None;
  //key_event.time 	= CurrentTime;
  key_event.x 		= 1;
  key_event.y 		= 1;
  key_event.x_root 	= 1;
  key_event.y_root	= 1;
  key_event.same_screen = true;
  key_event.state 	= state;
  
  key_event.keycode 	= XKeysymToKeycode(display, XStringToKeysym(keysymstring));
  

  key_event.type = KeyPress;
  int error = XSendEvent(display, FocusWindow, True, KeyPressMask|KeyReleaseMask, (XEvent *)&key_event);
  //assert(error);
  if (error==BadValue) 
  { 
   printf("Bad Value.\n");
   
  }
   
  if (error==BadWindow) 
  {
   printf("Bad Window.\n");
   
  }
}
//*****************************************************************************
// CWindow Load KeyMap Data
//*****************************************************************************
void GrabKeyboard::LoadKeyMapData(char *filename)
{
    fstream File;
    CMap Text;
    File.open(filename,ios::in);
  
    while(!File.eof())
    {
     File.read((char*)&Text,sizeof(CMap));
     if(!TransMapping[(int)Text.Ascii[0]].isPresent(Text.Ascii))
       TransMapping[(int)Text.Ascii[0]].insert(Text);
    }
    File.close();    	
}
//*****************************************************************************
// Ends here
//*****************************************************************************
